// HiResTimer
// Sub-millisecond accurate timer.
// Works on Windows, Linux and Mac OS 
//
// Copright 2011 by Keith Vertanen

#ifndef __HIRES_TIMER_H__
#define __HIRES_TIMER_H__

#include <sys/timeb.h>
#include <time.h>
#include <stdio.h>

#ifdef _WIN32
#include <Windows.h>
#endif

#ifdef __APPLE__
#include <mach/mach_time.h>
#include <stdint.h>
#endif


class HiResTimer
{
public:
    HiResTimer();
    ~HiResTimer();

    double	GetElapsed();
	void	Reset();

private:
#ifdef _WIN32
	LARGE_INTEGER	m_startTime;
	LARGE_INTEGER	m_freq;
#elif __APPLE__
	uint64_t        m_startTime;
	double          m_conversion;
#else
	timespec	m_startTime;
	timespec	m_freq;
#endif

};

#endif

