// SocketServerDataGram
// Subclass for a server that is sending/receiving datagrams using UDP.
// Will receive datagrams from any sender on the designated port.
// If not specified, will send bytes back to whoever we last received a datagram from.
// Otherwise the caller can ask for bytes to be sent to any host and port.
#ifndef __SOCKET_SERVER_DATAGRAM_H__
#define __SOCKET_SERVER_DATAGRAM_H__

#include "Socket.h"

class SocketServerDatagram : public Socket
{
	public:
		SocketServerDatagram(int port, int flags, bool& good);
		
		int			SendBytes(const char* host, int port, char* buffer, int maxlen);
		int			SendBytes(char* buffer, int maxlen);
		int			RecvBytes(char* buffer, int maxlen);
		PeerInfo	GetPeerInfo();

	protected:
		PeerInfo	m_lastPeer;		// Stores peer info of last sender

};

#endif
